#ifndef MAINMENU_H
#define MAINMENU_H

#include "gui/scene.h"

class ButtonHoverWatcher : public QObject
{
    Q_OBJECT
public:
    explicit ButtonHoverWatcher(QObject * parent = Q_NULLPTR);
    virtual bool eventFilter(QObject * watched, QEvent * event) Q_DECL_OVERRIDE;
};

namespace Ui {
class MainMenu;
}

class MainMenu : public Scene
{
    Q_OBJECT

public:
    explicit MainMenu(QWidget *parent = 0);
    ~MainMenu();

    void init() override;

private slots:

    void on_hotseat_button_clicked();

    void on_leave_game_button_clicked();

private:
    Ui::MainMenu *ui;
    QMovie* movie;
    ButtonHoverWatcher * watcher;
};

#endif // MAINMENU_H
